/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Embeddable;

@Embeddable
public class CodigoAdministracaoFuncionario implements Serializable
{
	private static final long serialVersionUID = 7679228674443658287L;

	private String matriculaAdministrador;
	private short codigoInstituicao;
	private short codigoSetor;
	
	@Column(name = "COD_ADMINISTRADOR")
	public String getMatriculaAdministrador()
	{
		return matriculaAdministrador;
	}
	
	public void setMatriculaAdministrador(String matriculaAdministrador)
	{
		this.matriculaAdministrador = matriculaAdministrador;
	}
	
	@Column(name = "COD_INSTITUICAO")
	public short getCodigoInstituicao()
	{
		return codigoInstituicao;
	}
	
	public void setCodigoInstituicao(short codigoInstituicao)
	{
		this.codigoInstituicao = codigoInstituicao;
	}
	
	@Column(name = "COD_SETOR")
	public short getCodigoSetor()
	{
		return codigoSetor;
	}
	
	public void setCodigoSetor(short codigoSetor)
	{
		this.codigoSetor = codigoSetor;
	}

	@Override
	public boolean equals(Object obj)
	{
		if (this == obj)
		{
			return true;
		}
		if (obj == null)
		{
			return false;
		}
		if (getClass() != obj.getClass())
		{
			return false;
		}
		
		CodigoAdministracaoFuncionario outro =
			(CodigoAdministracaoFuncionario) obj;
		
		if (matriculaAdministrador == null)
		{
			if (outro.getMatriculaAdministrador() != null)
			{
				return false;
			}
		}
		else if (!matriculaAdministrador.equals(
			outro.getMatriculaAdministrador()))
		{
			return false;
		}
		if (codigoInstituicao != outro.getCodigoInstituicao())
		{
			return false;
		}
		if (codigoSetor != outro.getCodigoSetor())
		{
			return false;
		}
		return true;
	}
	
	@Override
	public int hashCode()
	{
		final int PRIMO = 31;
		int resultado = 1;
		resultado =	PRIMO * resultado +
			(matriculaAdministrador == null ?
			0 : matriculaAdministrador.hashCode());
		resultado = PRIMO * resultado + codigoInstituicao;
		resultado = PRIMO * resultado + codigoSetor;
		return resultado;
	}
}
