/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Embeddable;

@Embeddable
public class CodigoPermissaoFuncionario implements Serializable
{
	private static final long serialVersionUID = -290275110161448751L;
	
	private String matriculaFuncionario;
	private short codigoInstituicao;
	private short codigoSetor;
	private TipoPermissao tipo;
	
	@Column(name = "COD_FUNCIONARIO")
	public String getMatriculaFuncionario()
	{
		return matriculaFuncionario;
	}
	
	public void setMatriculaFuncionario(String matriculaFuncionario)
	{
		this.matriculaFuncionario = matriculaFuncionario;
	}
	
	@Column(name = "COD_INSTITUICAO")
	public short getCodigoInstituicao()
	{
		return codigoInstituicao;
	}
	
	public void setCodigoInstituicao(short codigoInstituicao)
	{
		this.codigoInstituicao = codigoInstituicao;
	}
	
	@Column(name = "COD_SETOR")
	public short getCodigoSetor()
	{
		return codigoSetor;
	}
	
	public void setCodigoSetor(short codigoSetor)
	{
		this.codigoSetor = codigoSetor;
	}

	@Column(name = "COD_PERMISSAO")
	public TipoPermissao getTipo()
	{
		return tipo;
	}

	public void setTipo(TipoPermissao tipo)
	{
		this.tipo = tipo;
	}

	@Override
	public boolean equals(Object obj)
	{
		if (this == obj)
		{
			return true;
		}
		if (obj == null)
		{
			return false;
		}
		if (getClass() != obj.getClass())
		{
			return false;
		}
		
		CodigoPermissaoFuncionario outro = (CodigoPermissaoFuncionario) obj;
		
		if (matriculaFuncionario == null)
		{
			if (outro.getMatriculaFuncionario() != null)
			{
				return false;
			}
		}
		else if (!matriculaFuncionario.equals(outro.getMatriculaFuncionario()))
		{
			return false;
		}
		if (codigoInstituicao != outro.getCodigoInstituicao())
		{
			return false;
		}
		if (codigoSetor != outro.getCodigoSetor())
		{
			return false;
		}
		if (tipo != outro.getTipo())
		{
			return false;
		}
		return true;
	}
	
	@Override
	public int hashCode()
	{
		final int PRIMO = 31;
		int resultado = 1;
		resultado =	PRIMO * resultado +	(matriculaFuncionario == null ?
			0 : matriculaFuncionario.hashCode());
		resultado = PRIMO * resultado + codigoInstituicao;
		resultado = PRIMO * resultado + codigoSetor;
		resultado = PRIMO * resultado + (tipo == null ? 0 : tipo.hashCode());
		return resultado;
	}
}
