/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Embeddable;

@Embeddable
public class CodigoSetor implements Serializable
{
	private static final long serialVersionUID = 2065064410129501084L;
	
	private short codigoInstituicao;
	private short codigoSetor;
	
	public CodigoSetor()
	{
	}
	
	public CodigoSetor(short codigoInstituicao, short codigoSetor)
	{
		this.codigoInstituicao = codigoInstituicao;
		this.codigoSetor = codigoSetor;
	}
	
	@Column(name = "COD_INSTITUICAO")
	public short getCodigoInstituicao()
	{
		return codigoInstituicao;
	}
	
	public void setCodigoInstituicao(short codigoInstituicao)
	{
		this.codigoInstituicao = codigoInstituicao;
	}
	
	@Column(name = "COD_SETOR")
	public short getCodigoSetor()
	{
		return codigoSetor;
	}
	
	public void setCodigoSetor(short codigoSetor)
	{
		this.codigoSetor = codigoSetor;
	}

	@Override
	public boolean equals(Object obj)
	{
		if (obj instanceof CodigoSetor)
		{
			CodigoSetor outro = (CodigoSetor) obj;
			return codigoInstituicao == outro.getCodigoInstituicao() && 
				codigoSetor == outro.getCodigoSetor();
		}
		return false;
	}

	@Override
	public int hashCode()
	{
		final int primo = 31;
		int resultado = 1;
		resultado = primo * resultado + codigoInstituicao;
		resultado = primo * resultado + codigoSetor;
		return resultado;
	}
}
