/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes;

public abstract class InformacoesFuncionario
{
	private final String fMatricula;
	private final String fNome;
	
	protected InformacoesFuncionario(String matricula, String nome)
	{
		if (matricula == null)
		{
			throw new NullPointerException("Matrcula nula.");
		}
		if (nome == null)
		{
			throw new NullPointerException("Nome nulo.");
		}
		fMatricula = matricula;
		fNome = nome;
	}
	
	public String getMatricula()
	{
		return fMatricula;
	}
	
	public String getNome()
	{
		return fNome;
	}
	
	@Override
	public boolean equals(Object obj)
	{
		if (this == obj)
		{
			return true;
		}
		if (obj == null)
		{
			return false;
		}
		if (getClass() != obj.getClass())
		{
			return false;
		}
		
		InformacoesFuncionario outro = (InformacoesFuncionario) obj;
		
		return fMatricula.equals(outro.fMatricula);
	}
	
	@Override
	public int hashCode()
	{
		return fMatricula.hashCode();
	}
	
	@Override
	public String toString()
	{
		return fNome;
	}
}
