/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name = "SO_PERMISSOES_FUNCIONARIOS")
public class PermissaoFuncionario
{
	private CodigoPermissaoFuncionario codigo;
	private Funcionario funcionario;
	private Setor setor;

	@EmbeddedId
	public CodigoPermissaoFuncionario getCodigo()
	{
		return codigo;
	}

	public void setCodigo(CodigoPermissaoFuncionario codigo)
	{
		this.codigo = codigo;
	}

	@ManyToOne
	@JoinColumn(name = "COD_FUNCIONARIO", referencedColumnName = "MATRICULA",
		insertable = false, updatable = false)
	public Funcionario getFuncionario()
	{
		return funcionario;
	}
	
	public void setFuncionario(Funcionario funcionario)
	{
		this.funcionario = funcionario;
	}

	@ManyToOne
	@JoinColumns({
		@JoinColumn(name = "COD_INSTITUICAO",
			referencedColumnName = "COD_INSTITUICAO",
			insertable = false, updatable = false), 
		@JoinColumn(name = "COD_SETOR", 
			referencedColumnName = "COD_SETOR",
			insertable = false, updatable = false)
	})
	public Setor getSetor()
	{
		return setor;
	}

	public void setSetor(Setor setor)
	{
		this.setor = setor;
	}
}
