/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes;

import java.util.Set;

public class PermissoesFuncionario
{
	private boolean fConsultarSolicitacoesPessoais;
	private boolean fConsultarTodasSolicitacoes;
	private boolean fCriarSolicitacoes;
	private boolean fDarAndamentoSolicitacoes;
	
	PermissoesFuncionario()
	{
	}
	
	public PermissoesFuncionario(Set<TipoPermissao> permissoes)
	{
		inicializar(permissoes);
	}

	public boolean isConsultarSolicitacoesPessoais()
	{
		return fConsultarSolicitacoesPessoais;
	}

	void setConsultarSolicitacoesPessoais(boolean consultarSolicitacoesPessoais)
	{
		fConsultarSolicitacoesPessoais = consultarSolicitacoesPessoais;
	}

	public boolean isConsultarTodasSolicitacoes()
	{
		return fConsultarTodasSolicitacoes;
	}

	void setConsultarTodasSolicitacoes(boolean consultarTodasSolicitacoes)
	{
		fConsultarTodasSolicitacoes = consultarTodasSolicitacoes;
	}

	public boolean isCriarSolicitacoes()
	{
		return fCriarSolicitacoes;
	}

	void setCriarSolicitacoes(boolean criarSolicitacoes)
	{
		fCriarSolicitacoes = criarSolicitacoes;
	}

	public boolean isDarAndamentoSolicitacoes()
	{
		return fDarAndamentoSolicitacoes;
	}

	void setDarAndamentoSolicitacoes(boolean darAndamentoSolicitacoes)
	{
		fDarAndamentoSolicitacoes = darAndamentoSolicitacoes;
	}
	
	public boolean existem()
	{
		return fConsultarSolicitacoesPessoais ||
			fConsultarTodasSolicitacoes ||
			fCriarSolicitacoes ||
			fDarAndamentoSolicitacoes;
	}

	void inicializar(Set<TipoPermissao> permissoes)
	{
		fConsultarSolicitacoesPessoais =
			permissoes.contains(TipoPermissao.CONSULTAR_SOLICITACOES_PESSOAIS);
		fConsultarTodasSolicitacoes =
			permissoes.contains(TipoPermissao.CONSULTAR_TODAS_SOLICITACOES);
		fCriarSolicitacoes =
			permissoes.contains(TipoPermissao.CRIAR_SOLICITACOES);
		fDarAndamentoSolicitacoes =
			permissoes.contains(TipoPermissao.DAR_ANDAMENTO_SOLICITACOES);
	}
}
