/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes.web;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import br.urca.solicitacoes.SolicitacoesException;

public final class LocalizadorEJB
{
	private LocalizadorEJB()
	{
	}
	
	public static <T> T localizar(Class<T> classeInterface)
	{
		try
		{
			String nomeClasse =
				classeInterface.getSimpleName().substring(1) + "Bean";
			String localizacao = "solicitacoes-ear/" + nomeClasse + "/local";
			Context contexto = new InitialContext();
			@SuppressWarnings("unchecked")
			T ejb = (T) contexto.lookup(localizacao);
			return ejb;
		}
		catch (NamingException ex)
		{
			throw new SolicitacoesException(ex);
		}		
	}
}
