/**
 * @autor Marcos Antonio Pereira Silva
 */

package br.urca.solicitacoes.web;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.render.ResponseStateManager;

import com.sun.faces.renderkit.RenderKitUtils;

final class Utils
{
	private Utils()
	{
	}

	static boolean primeiraExibicao()
	{
		FacesContext contexto = FacesContext.getCurrentInstance();
		String idFerramentaExibicao = contexto.getViewRoot().getRenderKitId();
        ResponseStateManager gerenciadorEstadoResposta =
        	RenderKitUtils.getResponseStateManager(
        	contexto, idFerramentaExibicao);
        return !gerenciadorEstadoResposta.isPostback(contexto);
	}

	static void adicionarMensagemErro(String idComponente, String mensagem)
	{
		FacesMessage msg = new FacesMessage();
		String sumario = mensagem == null ? "Erro" : "Erro: " + mensagem;
		msg.setSummary(sumario);
		msg.setSeverity(FacesMessage.SEVERITY_ERROR);
		String id = idComponente == null ? null : "form:" + idComponente;
		FacesContext.getCurrentInstance().addMessage(id, msg);
	}
	
	static String formatarQuebrasDeLinhas(String texto)
	{
		if (texto != null)
		{
			return texto.replaceAll(
				System.getProperty("line.separator"), "<br />");
		}
		return texto;
	}

	static void focalizarComponente(String id)
	{
		focalizarComponente(id, false);
	}
	
	static void focalizarComponente(String id, boolean usarValorSubmetido)
	{
		UIInput detentorIdComponenteFocalizado =
			(UIInput) FacesContext.getCurrentInstance().getViewRoot().
			findComponent("form:componenteFocalizado");
		if (usarValorSubmetido)
		{
			detentorIdComponenteFocalizado.setSubmittedValue(id);
		}
		else
		{
			detentorIdComponenteFocalizado.setValue(id);
		}
	}
}
